=== debian/changelog ===
python-igraph (0.9.9-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 23:08:24 +0000

python-igraph (0.9.9-1) unstable; urgency=medium

  * Team upload.
  * Drop unused debian/*.in files
  * Do not Build-Depend from libigraph-dev.  In the long term debian packaged
    libigraph should be used instead of a code copy.
    Closes: #1003829

 -- Andreas Tille <tille@debian.org>  Thu, 27 Jan 2022 08:25:35 +0100

python-igraph (0.9.8-1) unstable; urgency=medium

  * d/watch: Follow upstream project name change.
  * New upstream version 0.9.8

 -- TANIGUCHI Takaki <takaki@debian.org>  Sun, 28 Nov 2021 22:26:58 +0900

python-igraph (0.9.6-1) unstable; urgency=medium

  * New upstream version 0.9.6
  * Bump Standards-Version to 4.6.0

 -- TANIGUCHI Takaki <takaki@debian.org>  Sat, 11 Sep 2021 18:49:50 +0900
