=== debian/control ===
Source: python-igraph
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: TANIGUCHI Takaki <takaki@debian.org>,
           Hugo Lefeuvre <hle@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
#               libigraph-dev, FIXME: In the long term debian packaged libigraph should be used instead of a code copy
               pkg-config,
               python3-all-dev,
               python3-numpy,
               python3-setuptools,
               python3-texttable,
		bison,
		flex,
		libxml2-dev,
		cmake
Standards-Version: 4.6.0
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python
Homepage: https://igraph.org/python/
Vcs-Git: https://salsa.debian.org/python-team/packages/python-igraph.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-igraph

Package: python3-igraph
Architecture: any
Depends: python3-texttable,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: High performance graph data structures and algorithms (Python 3)
 Python interface to the igraph high performance graph library, primarily
 aimed at complex network research and analysis.
 .
 Graph plotting functionality is provided by the Cairo library, so make
 sure you install the Python bindings of Cairo if you want to generate
 publication-quality graph plots.
 .
 This package contains the Python 3 version of igraph.
