=== vendor/source/igraph/tests/CMakeLists.txt ===
--- 
+++ 
@@ -113,7 +113,6 @@
   2wheap
   cutheap
   d_indheap
-  hashtable
   marked_queue
   set
   trie
@@ -516,7 +515,6 @@
   FOLDER examples/simple NAMES
   igraph_community_edge_betweenness
   igraph_community_fastgreedy
-  igraph_community_fluid_communities
   igraph_community_label_propagation
   igraph_community_leading_eigenvector
   igraph_community_leiden
@@ -531,6 +529,8 @@
   community_label_propagation
   community_label_propagation2
   community_label_propagation3
+  community_walktrap
+  igraph_community_fluid_communities
   igraph_community_infomap
   igraph_community_leading_eigenvector2
   igraph_compare_communities
@@ -539,6 +539,7 @@
   igraph_modularity_matrix
   igraph_split_join_distance
   levc-stress
+  null_communities
   spinglass
 )
 add_legacy_tests(
@@ -585,5 +586,3 @@
   FOLDER examples/simple NAMES
   cattributes
   cattributes2
-  cattributes3
-  cattributes4
