=== debian/changelog ===
python-igraph (0.9.11-1) unstable; urgency=medium

  * New upstream version 0.9.11
  * Bump Standards-Version to 4.6.1.

 -- TANIGUCHI Takaki <takaki@debian.org>  Wed, 20 Jul 2022 19:02:37 +0900
